(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
	typeof define === 'function' && define.amd ? define(factory) :
	(global.highlight = factory());
}(this, (function () { 'use strict';

function encode$1(str, jsUnicode) {
	if ( jsUnicode === void 0 ) jsUnicode = true;

	var result = [];
	var len = str.length;
	for (var i = 0; i < len; i++) {
		var hex = str.charAt(i).charCodeAt(0).toString(16);
		if (jsUnicode) {
			result.push(("\\u" + (((("000" + hex)).slice(-4)))));
		} else {
			result.push(hex);
		}
	}
	return result.join('')
}

function decode(hex, jsUnicode) {
	if ( jsUnicode === void 0 ) jsUnicode = true;

	var _hex = hex.toString();
	if (jsUnicode) {
		return _hex
	}
	var result = [];
	var len = _hex.length;
	for (var i = 0; i < len; i += 2) {
		result.push(String.fromCharCode(parseInt(_hex.substr(i, 2), 16)));
	}
	return result.join('')
}

var encode_1 = encode$1;
var decode_1 = decode;

var index$2 = {
	encode: encode_1,
	decode: decode_1
};

var encode = index$2.encode;

var spade = '\u2664';

function _mapWords(words) {
	var map = {};
	for (var i = 0; i < words.length; i++) {
		var word = words[i];
		if (word) {
			var n = "" + spade + i;
			map[n] = word;
		}
	}
	return map
}

function highlight(source, q, tpl, split) {
	if ( tpl === void 0 ) tpl = '<mark>$&</mark>';
	if ( split === void 0 ) split = true;

	var words = (split ? q.split(' ') : [q]).sort(function (a, b) { return b.length - a.length; });
	var map = _mapWords(words);
	for (var i = 0; i < words.length; i++) {
		var word = words[i];
		if (word) {
			var regex$1 = new RegExp(("(" + (encode(word)) + ")"), 'ig');
			var n = "" + spade + i;
			source = source.replace(regex$1, n);
		}
	}
	var regex = new RegExp(("(" + spade + "[0-9+])"), 'g');
	return source.replace(regex, function (m) { return m.replace(m, tpl).replace(m, map[m]); })
}

var index = highlight;

return index;

})));
//# sourceMappingURL=index.js.map
